/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#include <stdio.h>
#include <fstream>
#include "Logger.h"

/**
Constructor
\param file to write log into
*/
Logger::Logger(char *file)
{
	output.open(file, std::ios_base::out | std::ios_base::app);
}

/**
Desctructor
*/
Logger::~Logger()
{
	if (output != NULL)
	{
		output.close();
	}
}

/**
Method for writting into the log file
\param line string with the line to write
*/
void Logger::WriteToLog(std::string line)
{
	if (!line.empty()) 
	{
		output.write(line.c_str(), line.length());
		output.write("\r\n", 2);
	}
}
