/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef OSD_H
#define OSD_H

#include <windows.h>
#include "../stdafx.h"
#include <Streams.h> // needs path to baseclasses directory (added to project path for includes)
#include <Dshow.h>
#include <string>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "Utils.h"

class OSD
{
private:
	IVMRMixerBitmap* g_pBMP;
	LONG g_lFontPointSize;
	TCHAR g_szFontName[100];
	TCHAR g_szFontStyle[32];
	COLORREF g_rgbColors;
	bool isOSDVisible;

public:
	OSD();
	~OSD();
	IVMRMixerBitmap* GetVMRMixerBitmap();
	HRESULT SetVMRMixerBitmap(IBaseFilter* pWindowlessFilter);
	HRESULT BlendApplicationText(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, TCHAR *szNewText);
	HFONT SetTextFont(HWND appWindow);
	HRESULT SetOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, TCHAR* szOSDText);
	void PrepareAndShowOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, IMediaPosition* pMediaPosition, IBasicAudio* pBasicAudio);
	void RefreshOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, IMediaPosition* pMediaPosition, IBasicAudio* pBasicAudio);
	HRESULT BlendVotingSlider(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, int curVote);
	HRESULT SetVotingOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl);
	void PrepareAndShowVotingOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl);
	void RefreshVotingOSD(HWND hwndApp, IVMRWindowlessControl* pWindowlessControl, int curVote);
	bool IsOSDVisible();

private:
	void SetColorRef(VMRALPHABITMAP& bmpInfo);
};

#endif