/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef ELEMENT_H
#define ELEMENT_H

#include "../stdafx.h"
#include <map>
#include <string>
#include <iostream>

class Element
{
private:
	std::map<std::string, std::string> m_value;
	int i_type;
	double l_time;
	double played_time;

public:
	Element();
	~Element();
	std::map<std::string, std::string> GetValues();
	std::string GetValue(std::string identifier);
	void AddValue(std::string identifier, std::string value);
	double GetTime() const;
	void SetTime(double time);
	void SetPlayedTime(double time);
	double GetPlayedTime();
	void Print();
	void SetType(int type);
	int GetType();
};

#endif
