/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef FAN_H
#define FAN_H

#include "../stdafx.h"

#if __USEAMBX__
#include "../3rdParties/ambx/IamBX_Fan.h"
#endif

class Fan
{
#if __USEAMBX__
public:
	Fan(IamBX_Fan* fan);
	~Fan();
	bool IsFadeActive();
	bool IsFanActive();
	double GetEffectDifference();
	double GetOldIntensityValue();
	double GetDuration();
	double GetIntensity();
	double GetFadeTime();
	double GetIntermediateIntensity();
	double GetPTS();
	void ActivateFan(bool activate);
	void SetIntensity(double intensity);
	void SetDuration(double duration);
	void SetOldIntensityValue(double oldIntensity);
	void SetEffectDifference(double difference);
	void SetFadeTime(double fadeCount);
	void ActivateFade(bool activate);
	void SetIntermediateIntensity(double intensity);
	void SetPTS(double time);
	void ResetFan();

	// devices settings

	amBX_RESULT SetIntensityToDevice(float intensity);
	float GetIntensityFromDevice();

	IamBX_Fan *GetFan();

private:
	IamBX_Fan *m_fan;
	bool bFanFade;
	bool fanActive;
	double fanFadeTime;
	double fanEffectDifference;
	double fanOldIntensityValue;
	double fanDuration;
	double fanIntensity;
	double fanIntermediateIntensity;
	double fanPTS;
#endif
};

#endif