/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef FANCONTAINER_H
#define FANCONTAINER_H

#include "../stdafx.h"

#if __USEAMBX__
#include "../3rdParties/ambx/amBX_Types.h"
#endif

#include "Fan.h"
#include <map>
#include <vector>

// Currently only one fan per position is allowed!

class FanContainer
{
#if __USEAMBX__
public:
	FanContainer();
	~FanContainer();
	void AddFan(amBX_loc location, Fan* fan);
	Fan* GetFan(amBX_loc location);
	std::vector<Fan *> GetAllFans();

private:
	std::map<amBX_loc, Fan*> fanMap;
#endif
};

#endif