/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef LIBXML_H
#define LIBXML_H

#include "../stdafx.h"
#include <vector>
#include <string>
#include "Element.h"
#include "../3rdParties/libxml/xmlreader.h"

class Libxml
{
private:
	void ProcessNode(xmlTextReaderPtr reader);
	bool m_anchorElement;
	long m_timeScale;
	double m_curTime;
	Element *m_tmpElement;
	void StreamFile(const char *filename);
	std::vector<Element*> *m_Elements;
	static bool ElementCompare(const Element* element1, const Element* element2);
	bool m_bAutoColor;

	// used for faster branch recognition
	// note: ReferenceEffects are currently ignored!
	static const int iSEM = 0;
	static const int iGOE = 1;
	static const int iEFFECT = 2;

public:
	Libxml();
	~Libxml();
	std::vector<Element*> Parse(const char* filename);
	bool IsAutoColorActivated();
	long GetTimeScale();
};

#endif
