/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef LIGHT_H
#define LIGHT_H

#include "../stdafx.h"

#if __USEAMBX__
#include "../3rdParties/ambx/IamBX_Light.h"
#endif

class Light
{
#if __USEAMBX__
public:
	Light(IamBX_Light* light);
	~Light();
	bool IsFadeActive();
	double GetDuration();
	double GetIntensity();
	double GetOldIntensityValue();
	double GetFadeTime();
	double GetEffectDifference();
	double GetPTS();
	int *GetLightColor();
	void SetIntensity(double intensity);
	void SetOldIntensityValue(double oldIntensity);
	void SetDuration(double duration);
	void SetFadeTime(double fadeTime);
	void SetEffectDifference(double difference);
	void ActivateFade(bool activate);
	void ResetLight();
	void SetPTS(double time);
	IamBX_Light *GetLight();
	void SetLightColor(int r, int g, int b);

private:
	IamBX_Light *m_light;
	bool bLightFade;
	double lightFadeTime;
	double lightDuration;
	double lightIntensity;
	double lightOldIntensityValue;
	double lightEffectDifference;
	int lightColor[3]; // RGB
	double lightPTS;
#endif
};

#endif