/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef LIGHTCONTAINER_H
#define LIGHTCONTAINER_H

#include "../stdafx.h"

#if __USEAMBX__
#include "../3rdParties/ambx/amBX_Types.h"
#endif

#include "Light.h"
#include <map>
#include <vector>

// Currently only one light per position is allowed!

class LightContainer
{
#if __USEAMBX__
public:
	LightContainer();
	~LightContainer();
	void AddLight(amBX_loc location, Light* light);
	Light* GetLight(amBX_loc location);
	std::vector<Light *> GetAllLights();

private:
	std::map<amBX_loc, Light*> lightMap;
#endif
};

#endif