/*
 * This file is part of SEMP.
 *
 * SEMP is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * SEMP is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with SEMP. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, 2010, 2011, 2012 Alpen-Adria-Universitaet Klagenfurt, Markus Waltl.
 */

#ifndef SCENT_H
#define SCENT_H

#include "../stdafx.h"
#include <windows.h>
#include <string>

// class is used on a per fan basis based
// on the VortexActive device
class Scent
{
public:
	Scent(int id, std::string scent);
	~Scent();
	bool IsFadeActive();
	double GetDuration();
	double GetIntensity();
	double GetOldIntensityValue();
	double GetFadeTime();
	double GetEffectDifference();
	double GetPTS();
	std::string GetScent();
	void SetIntensity(double intensity);
	void SetOldIntensityValue(double oldIntensity);
	void SetDuration(double duration);
	void SetFadeTime(double fadeTime);
	void SetEffectDifference(double difference);
	void ActivateFade(bool activate);
	void ResetScent();
	void SetPTS(double pts);
	int GetFanID();

private:
	int fanId;
	bool bScentFade;
	double scentFadeTime;
	double scentDuration;
	double scentIntensity;
	double scentOldIntensityValue;
	double scentEffectDifference;
	std::string scentType;
	double scentPTS;
};

#endif